; PngSkin III example by Qweerdy
; This example shows some cool stuff, like a scrollbar and colorizing a skin at run time.
; This program contains code by bitRAKE, Eoin, and Iblis' HSL conversion routines.

.586
.mmx
.model flat,stdcall
option casemap:none

include pngskin.inc

start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,WS_EX_LAYERED,ADDR ClassName,ADDR AppName,\
           WS_POPUP,100,\
           100,96,96,NULL,NULL,\
           hInst,NULL
	mov   hWin,eax
	
	invoke ShowWindow, hWin,SW_SHOWNORMAL
	invoke UpdateWindow, hWin
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE

	.data
		dcScreen dd ?
		bButtons dd ?
		bSkin dd ?
		bMain dd ?
		pngSize dd ?,?
		pngSize2 dd ?,?
	.code

	;>> Get screen DC for CreateCompatibleDC
		invoke GetDC,0
		mov dcScreen,eax
		
	;>> Load the png containing the main window tiles
		invoke LoadPng,1,addr pngSize
		mov bSkin,eax
		invoke CreateCanvas,dcScreen,pngSize,pngSize+4
		mov bMain,eax
		
	;>> Load the png containing the buttons
		invoke LoadPng,2,addr pngSize2
		mov bButtons,eax
		
		invoke PaintWindow,hWnd
		
	.ELSEIF uMsg==WM_LBUTTONDOWN
		.data?
			hTimer dd ?
			ScrollDir dd ?
			ScrollHandleY dd ?
		.code
		mov eax,lParam
		mov edx,eax
		and eax,0ffffh ; eax=x
		shr edx,16	   ; edx=y
		.if edx<ws.horizy
			.if eax<ws.vertx
				invoke PostMessage,hWnd,WM_NCLBUTTONDOWN,HTTOPLEFT,0
			.elseif eax<ws.rightx
				invoke PostMessage,hWnd,WM_NCLBUTTONDOWN,HTTOP,0
			.else
				invoke PostMessage,hWnd,WM_NCLBUTTONDOWN,HTTOPRIGHT,0
			.endif
		.elseif edx<ws.downy
			.if eax<ws.vertx
				invoke PostMessage,hWnd,WM_NCLBUTTONDOWN,HTLEFT,0
			.elseif eax<ws.rightx
			
			;>> Begin scrollbar code
				mov ecx,ws.w
				sub ecx,45
				.if eax>ecx
					sub ecx,20
					.if eax>ecx
						mov ecx,ws.h
						sub ecx,44
						.if edx>18 && edx<38
							.if ScrollPos
								dec ScrollPos
								invoke PaintWindow,hWnd
								mov ScrollDir,-1
								invoke SetCapture,hWnd
								invoke SetTimer,hWnd,1,200,NULL
								mov hTimer,eax
								xor eax,eax
								ret
							.endif
						.elseif edx>ecx
							add ecx,20
							.if edx<ecx
								mov ecx,ScrollPos
								.if ecx<ScrollMax
									inc ScrollPos
									invoke PaintWindow,hWnd
									mov ScrollDir,1
									invoke SetCapture,hWnd
									invoke SetTimer,hWnd,1,200,NULL
									mov hTimer,eax
									xor eax,eax
									ret
								.endif
							.endif
						.elseif edx>ScrollHandleY
							sub edx,20
							.if edx<ScrollHandleY
								mov ScrollDir,2
								invoke SetCapture,hWnd
								xor eax,eax
								ret
							.endif
						.endif
					.endif
				.endif
			;>> End scrollbar code
				
				invoke PostMessage,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,0 ;!!!!
			.else
				invoke PostMessage,hWnd,WM_NCLBUTTONDOWN,HTRIGHT,0
			.endif
		.else
			.if eax<ws.vertx
				invoke PostMessage,hWnd,WM_NCLBUTTONDOWN,HTBOTTOMLEFT,0
			.elseif eax<ws.rightx
				invoke PostMessage,hWnd,WM_NCLBUTTONDOWN,HTBOTTOM,0
			.else
				invoke PostMessage,hWnd,WM_NCLBUTTONDOWN,HTBOTTOMRIGHT,0
			.endif
		.endif
		
;>> Begin scrollbar code
	.ELSEIF uMsg==WM_LBUTTONUP
		.if ScrollDir
			invoke KillTimer,hWnd,hTimer
			mov hTimer,0
			invoke ReleaseCapture
			mov ScrollDir,0
		.endif
	.ELSEIF uMsg==WM_TIMER
		.if wParam==1
			push hTimer
			invoke SetTimer,hWnd,2,50,0
			mov hTimer,eax
			pop eax
			invoke KillTimer,hWnd,eax
		.else
			.if ScrollDir==1
				mov ecx,ScrollPos
				.if ecx<ScrollMax
					inc ScrollPos
				.endif
			.else
				.if ScrollPos
					dec ScrollPos
				.endif
			.endif
			invoke PaintWindow,hWnd
		.endif
;>> End scrollbar code
		
	.ELSEIF uMsg==WM_MOUSEMOVE
		mov eax,lParam
		mov edx,eax
		and eax,0ffffh ; eax=x
		shr edx,16	   ; edx=y
	;>> Begin scrollbar code
		.if ScrollDir==2
			mov eax,edx
			sub eax,38+10
			js @F
			mov edx,ws.h
			sub edx,18+44+20+20
			cmp eax,edx
			jns @F
			mov ecx,ws.h
			sub ecx,18+44+20+20
			shl eax,8
			xor edx,edx
			div ecx
			mov edx,ScrollMax
			mul edx
			shr eax,8
			mov ScrollPos,eax
			invoke PaintWindow,hWnd
		@@:
			xor eax,eax
			ret
	;>> End scrollbar code
	
;		.else
;			.data
;				CurrentPos dd 0ffffffffh
;			.code
;			.if edx<ws.horizy
;				.if eax<ws.vertx
;					mov ecx,IDC_SIZENESW
;				.elseif eax<ws.rightx
;					mov ecx,IDC_SIZENS
;				.else
;					mov ecx,IDC_SIZENWSE
;				.endif
;			.elseif edx<ws.downy
;				.if eax<ws.vertx
;					mov ecx,IDC_SIZEWE
;				.elseif eax<ws.rightx
;					mov ecx,IDC_ARROW
;				.else
;					mov ecx,IDC_SIZEWE
;				.endif
;			.else
;				.if eax<ws.vertx
;					mov ecx,IDC_SIZENWSE
;				.elseif eax<ws.rightx
;					mov ecx,IDC_SIZENS
;				.else
;					mov ecx,IDC_SIZENESW
;				.endif
;			.endif
;			.if ecx!=CurrentPos
;				mov CurrentPos,ecx
;				invoke LoadCursor,hInstance,ecx
;				invoke SetCursor,eax
;			.endif
		.endif
    .ELSEIF uMsg==WM_SIZE
		mov eax,lParam
		mov edx,eax
		and eax,0ffffh ; eax=x
		shr edx,16	   ; edx=y
		mov ws.w,eax
		mov ws.h,edx
		sub eax,24
		sub edx,24
		mov ws.rightx,eax
		mov ws.downy,edx
		invoke PaintWindow,hWnd
	.ELSEIF uMsg==WM_SIZING
		mov edx,lParam
		assume edx:ptr RECT
		mov eax,[edx].right
		sub eax,[edx].left
		.if eax<150
			mov eax,[edx].left
			add eax,150
			mov [edx].right,eax
		.endif
		mov eax,[edx].bottom
		sub eax,[edx].top
		.if eax<150
			mov eax,[edx].top
			add eax,150
			mov [edx].bottom,eax
		.endif
		assume edx:nothing
		mov eax,TRUE
		ret
    .ELSEIF uMsg==WM_RBUTTONUP
    	; Close the window when clicking right mouse button
   		invoke PostMessage,hWnd,WM_CLOSE,0,0
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	xor eax,eax
	ret
WndProc endp

PaintWindow proc uses esi edi ebx hWnd:dword
	
	.data?
		dcWin dd ?
		bWin dd ?
		dcOld dd ?
		bOld dd ?
		dcTxt dd ?
		bTxt dd ?
		bBlur dd ?
	.data
		firstflag dd 1
	.code
	
	.if firstflag==0
		m2m dcOld,dcWin
		m2m bOld,bWin
		invoke DeleteObject,bTxt
		invoke DeleteDC,dcTxt
	.endif

	mov eax,ScrollPos
	invoke ColorizeSkin,bSkin,bMain,al

;>> Create a DC and blank bitmap for the window's appearance
	invoke CreateCompatibleDC,dcScreen
	mov dcWin,eax
	invoke CreateCanvas,dcWin,ws.w,ws.h
	mov bWin,eax
	invoke SelectObject,dcWin,bWin
	
;>> Create temp DC for text output and set the font
	invoke CreateCompatibleDC,dcScreen
	mov dcTxt,eax
	invoke CreateCanvas,dcTxt,ws.w,ws.h
	mov bTxt,eax
	invoke SelectObject,dcTxt,bTxt
	invoke CreateFont,20,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,CLEARTYPE_QUALITY or ANTIALIASED_QUALITY,DEFAULT_PITCH or FF_DONTCARE,CTEXT("Verdana") 
	invoke SelectObject,dcTxt,eax
	
;>> Paint the main skin (background)
	invoke PaintSkin,bWin
	
;>> Paint the text
	.data
		Txt db "Hue: "
		buffer db 20 dup(?)
	.code
	invoke dwtoa,ScrollPos,addr buffer
	invoke PaintText,dcTxt,bTxt,dcWin,bWin,addr Txt,18,12
	
;>> Paint the buttons
	mov ebx,ws.w
	sub ebx,45
	.if ebx>0
		invoke AlphaBlend2,bButtons,0,0,20,20,bWin,ebx,18
		mov eax,ws.h
		sub eax,18+44+20+20
		shl eax,8
		xor edx,edx
		div ScrollMax
		shl edx,1
		.if edx>=ScrollMax
			inc edx
		.endif
		mul ScrollPos
		shr eax,8
		add eax,38
		mov ScrollHandleY,eax
		invoke AlphaBlend2,bButtons,0,20,20,20,bWin,ebx,eax
		mov eax,ws.h
		sub eax,44
		.if eax>0
			invoke AlphaBlend2,bButtons,0,40,20,20,bWin,ebx,eax
		.endif
	.endif
			
;>> Pre-multiply the window's appearance (Windows needs this)
	invoke PreMul,bWin

;>> Set the window's appearance to the DC
	invoke UpdateLayeredWindow,hWnd,dcScreen,0,addr ws.w,dcWin,addr ptZero,0,addr blender,ULW_ALPHA
	.if eax==0
		invoke MessageBox,hWnd,CTEXT("UpdateLayeredWindow failed."),0,0
		invoke ExitProcess,0
	.endif

	.if firstflag==0
		invoke DeleteObject,bOld
		invoke DeleteDC,dcOld
	.endif
	
	mov firstflag,0

	ret

PaintWindow endp

; Inner loop by bitRAKE. It's called AlphaBlend2 because WinXP already has a "AlphaBlend" API.
AlphaBlend2 proc hSrcBm:DWORD,srcx:DWORD,srcy:DWORD,srcw:DWORD,srch:DWORD,hDstBm:DWORD,dstx:DWORD,dsty:DWORD
	
LOCAL bmsrc:BITMAP
LOCAL bmdst:BITMAP
LOCAL srci:DWORD
LOCAL dsti:DWORD

	invoke GetObject,hSrcBm,sizeof bmsrc,addr bmsrc
	invoke GetObject,hDstBm,sizeof bmdst,addr bmdst
	
	mov eax,bmsrc.bmWidth
	sub eax,srcw
	shl eax,2
	mov srci,eax
	
	mov eax,bmdst.bmWidth
	sub eax,srcw
	shl eax,2
	mov dsti,eax
	
	mov eax,bmdst.bmWidth
	mov edx,bmdst.bmHeight
	sub edx,dsty
	sub edx,srch
	mul edx
	add eax,dstx
	shl eax,2
	add eax,bmdst.bmBits
	mov edx,eax
	push edx
	
	mov eax,bmsrc.bmWidth
	mov edx,bmsrc.bmHeight
	sub edx,srcy
	sub edx,srch
	mul edx
	add eax,srcx
	shl eax,2
	add eax,bmsrc.bmBits
	
	pop edx
	
	shr srcw,1
	
	; This code by bitRAKE
.data
	__FF000000FF000000 dq 0FF000000FF000000h
	__00FFFFFF00FFFFFF dq 000FFFFFF00FFFFFFh
.code
	
AlphaBlendLoop: ; 13056 ticks for 1000 quads on Athlon. 
    mov ecx,srcw ; number of pixels/2 
    dec ecx 
    pxor mm7,mm7 
    movq mm0,[eax+ecx*8] 
    movq mm1,[edx+ecx*8]
@@:	movq mm4,mm0
	movq mm6,mm0
	;psrlw mm6,1 ; optional effect
	paddusb mm6,mm1
	pand mm6,__FF000000FF000000
    movq mm2,mm0 
    psrlw mm4,1 
    movq mm3,mm1 
    movq mm5,mm4 
    punpcklbw mm0,mm7 
    punpcklbw mm1,mm7 
    punpckhbw mm2,mm7 
    punpckhbw mm3,mm7 
    psubsw mm0,mm1 
    psubsw mm2,mm3 
    punpcklwd mm4,mm4 
    punpckhwd mm5,mm5 
    punpckhdq mm4,mm4 
    punpckhdq mm5,mm5
    psllw mm0,1 
    psllw mm2,1 
    pmulhw mm0,mm4 
    pmulhw mm2,mm5
    paddsw mm0,mm1 
    paddsw mm2,mm3 
    packuswb mm0,mm2
	pand mm0,__00FFFFFF00FFFFFF
	por mm0,mm6
    ; stored alpha = (-dA * sA)/256 + dA (better!?)
    movq [edx+ecx*8],mm0
    dec ecx 
    js @F	; It crashes when I don't add this???
    movq mm0,[eax+ecx*8] 
    movq mm1,[edx+ecx*8] 
    jns @B
@@:
    mov ecx,srcw
    shl ecx,3
    add eax,ecx
    add edx,ecx    
    add eax,srci
    add edx,dsti
    dec srch
    jnz AlphaBlendLoop
    
	ret

AlphaBlend2 endp

PaintText proc hTmpDC:dword,hTmpBM:dword,hOutDC:dword,hOutBM:dword,pStr:dword,x:dword,y:dword
	
LOCAL lStr:dword
LOCAL TxtSize[2]:dword
LOCAL bminfo:BITMAP
LOCAL NextLine:dword
LOCAL StartOfs:dword
LOCAL pSrc:dword
LOCAL pDest:dword
	
	invoke StrLen,pStr
	mov lStr,eax
	invoke GetTextExtentPoint,hTmpDC,pStr,lStr,addr TxtSize
	
	invoke GetObject,hTmpBM,sizeof bminfo,addr bminfo
	mov esi,bminfo.bmBits
	mov pSrc,esi
	invoke GetObject,hOutBM,sizeof bminfo,addr bminfo
	mov edi,bminfo.bmBits
	mov pDest,edi
	
	mov eax,bminfo.bmWidth
	sub eax,TxtSize
	shl eax,2
	mov NextLine,eax
	
	mov eax,bminfo.bmWidth
	mov edx,bminfo.bmHeight
	sub edx,y
	sub edx,TxtSize+4
	mul edx
	add eax,x
	shl eax,2
	mov StartOfs,eax

;>> Step 1 - Correct the alpha values in the destination DC

	invoke SetBkMode,dcTxt,OPAQUE
	invoke TextOut,hTmpDC,x,y,pStr,lStr
		
	add esi,StartOfs
	add edi,StartOfs
	add edi,3
		
	mov ebx,TxtSize+4
yLoop:
	mov ecx,TxtSize
xLoop:
	mov eax,[esi]
	mov edx,eax
	rol edx,16
	ror eax,8
	and eax,0ffff00ffh
	add dx,ax
	shr edx,24
	add ax,dx
	and eax,0ffffh
	xor edx,edx
	 push ebx
	mov ebx,3
	div ebx
	 pop ebx
	not al
	.if al>[edi]
		mov [edi],al
	.endif
	add esi,4
	add edi,4
	dec ecx
	jnz xLoop
	add esi,NextLine
	add edi,NextLine
	dec ebx
	jnz yLoop
		
;>> Step 2 - Paint & copy the text

	invoke BitBlt,hTmpDC,x,y,TxtSize,TxtSize+4,hOutDC,x,y,SRCCOPY
	invoke SetBkMode,dcTxt,TRANSPARENT
	invoke TextOut,hTmpDC,x,y,pStr,lStr

	mov esi,pSrc
	mov edi,pDest
	add esi,StartOfs
	add edi,StartOfs

	mov ebx,TxtSize+4
yLoop2:
	mov ecx,TxtSize
xLoop2:
	mov eax,[esi]
	mov edx,[edi]
	and edx,0ff000000h
	or eax,edx
	mov [edi],eax
	add esi,4
	add edi,4
	dec ecx
	jnz xLoop2
	add esi,NextLine
	add edi,NextLine
	dec ebx
	jnz yLoop2	
	
	ret

PaintText endp

ColorizeSkin proc uses esi edi ebx hSrc:dword,hDst:dword,Hue:byte
LOCAL bm:BITMAP
	
	invoke GetObject,hDst,sizeof bm,addr bm
	mov edi,bm.bmBits
	invoke GetObject,hSrc,sizeof bm,addr bm
	mov esi,bm.bmBits
	mov eax,bm.bmHeight
	mul bm.bmWidth
	mov ebx,eax
@@:	mov eax,[esi]
	push eax
	invoke RGB2HSL,eax
	mov al,Hue
	invoke HSL2RGB,eax
	pop edx
	shr edx,24
	mov [edi],eax
	mov [edi+3],dl
	add esi,4
	add edi,4
	dec ebx
	jnz @B
	ret
	
ColorizeSkin endp

PaintSkin proc hDib:dword
LOCAL bminfo:BITMAP

	invoke GetObject,bMain,sizeof bminfo,addr bminfo
	mov esi,bminfo.bmBits
	invoke GetObject,hDib,sizeof bminfo,addr bminfo
	mov edi,bminfo.bmBits
	push 0
	push 32
	sub bminfo.bmHeight,64
	push bminfo.bmHeight

	mov ebx,32
	jmp SectionLoop
BlockLoop:
	sub esi,4*32*32*3
SectionLoop:
	mov eax,32
	sub ebx,32
	jns LineLoop
	mov eax,ebx
	;neg eax
	add eax,32
LineLoop:
	; Draw first 32 pixels
	mov ecx,32
	rep movsd
	; Draw middle pixels
	mov ecx,bminfo.bmWidth
	sub ecx,64
	mov edx,32
	MiddleLoop:
	movsd
	dec edx
	jnz @F
	mov edx,32
	sub esi,32*4
	@@:
	dec ecx
	jnz MiddleLoop
	shl edx,2
	add esi,edx
	; Draw last 32 pixels
	mov ecx,32
	rep movsd
	dec eax
	jnz LineLoop
	cmp ebx,0
	jg BlockLoop
	jns @F
	neg ebx
	mov eax,4*32*3
	mul ebx
	add esi,eax
	@@:
	pop ebx
	or ebx,ebx
	jnz SectionLoop
	
	ret

PaintSkin endp


; This code is largely ripped from loadfromresource example in PngLib by Thomas
LoadPng proc ID:dword,pSize:dword

; In: 	ID: 	Resource ID of PNG file to load
; Out:	pSize:	Struct that this points to is filled with width & height of PNG
;		eax		Contains the handle to the new DIB
	
LOCAL pngInfo:PNGINFO

	; --- Initialize structure ---
	invoke	PNG_Init, addr pngInfo
	
	; --- Load PNG resource ---
	invoke	PNG_LoadResource, addr pngInfo, hInstance, ID
	.IF		!eax
		xor		eax, eax
		jmp		@cleanup
	.ENDIF
	
	; --- Decode PNG data ---
	invoke	PNG_Decode, addr pngInfo
	.IF		!eax
		xor		eax, eax
		jmp		@cleanup
	.ENDIF
	
	; --- Create bitmap from PNG ---
	invoke	PNG_CreateBitmap, addr pngInfo, hWin, PNG_OUTF_AUTO, FALSE
	.IF		!eax
		xor		eax, eax
		jmp		@cleanup
	.ENDIF
	
	mov edi,pSize
	.if edi!=0
		lea esi,pngInfo
		movsd
		movsd
	.endif
	
	@cleanup:
	push	eax	
	
	; --- Cleanup ---
	invoke	PNG_Cleanup, addr pngInfo
	
	pop		eax
	ret				; Returns 0 if something went wrong, else bitmap handle

LoadPng endp

; This snippet from Eoin's GUIBackBufferShell2 example
CreateCanvas Proc hDC:dword,biWidth:dword,biHeight:dword
LOCAL bih:BITMAPINFOHEADER
LOCAL pBb:dword
	
	lea edx, bih
	mov (BITMAPINFOHEADER ptr [edx]).biSize, sizeof(BITMAPINFOHEADER)
	mov eax, biWidth
	mov (BITMAPINFOHEADER ptr [edx]).biWidth, eax
	mov eax, biHeight
	mov (BITMAPINFOHEADER ptr [edx]).biHeight, eax
	mov (BITMAPINFOHEADER ptr [edx]).biPlanes, 1
	mov (BITMAPINFOHEADER ptr [edx]).biBitCount, 32
	mov (BITMAPINFOHEADER ptr [edx]).biCompression, BI_RGB
	mov (BITMAPINFOHEADER ptr [edx]).biSizeImage, 0
	mov (BITMAPINFOHEADER ptr [edx]).biXPelsPerMeter, 0
	mov (BITMAPINFOHEADER ptr [edx]).biYPelsPerMeter, 0
	mov (BITMAPINFOHEADER ptr [edx]).biClrUsed, 0
	mov (BITMAPINFOHEADER ptr [edx]).biClrImportant, 0

	invoke CreateDIBSection, hDC, edx, DIB_RGB_COLORS, addr pBb, 0, 0
	ret
	
CreateCanvas EndP

PreMul proc hBmp:dword
LOCAL bminfo:BITMAP
	
	invoke GetObject,hBmp,sizeof bminfo,addr bminfo
	cmp bminfo.bmBitsPixel,32
	jne Abort
	mov esi,bminfo.bmBits
	mov edi,esi
yloop:
	mov ecx,bminfo.bmWidth
	xloop:
		; This code by bitRAKE
		mov eax,[esi]
		mov edx,eax
		rol eax,16
		shr edx,24 ; A
		mul dl	; B * A
		rol eax,8
		mul dl	; G * A
		rol eax,8
		mul dl	; R * A
		mov al,dl
		ror eax,8
		mov [esi],eax
		add esi,4
		dec ecx
		jnz xloop
	dec bminfo.bmHeight
	jnz yloop
Abort:
	ret

PreMul endp

end start
