lib macro libn
	include &libn&.inc
	includelib &libn&.lib
endm

include windows.inc

lib kernel32
lib user32
lib gdi32
lib pnglib
lib masm32
lib msimg32

include rgb2hsl.asm

CTEXT MACRO y:VARARG
	LOCAL sym

CONST segment
	IFIDNI <y>,<>
		sym db 0
	ELSE
		sym db y,0
	ENDIF
CONST ends

	EXITM <OFFSET sym>
ENDM

m2m MACRO M1, M2
	push M2
	pop  M1
ENDM

; Constants & struct missing from Windows.inc

WS_EX_LAYERED equ 80000h
ULW_COLORKEY equ 1h
LWA_COLORKEY equ 1h
ULW_ALPHA equ 2h
LWA_ALPHA equ 2h
ULW_OPAQUE equ 4h
AC_SRC_OVER equ 0h
AC_SRC_ALPHA equ 1h

BLENDFUNCTION STRUCT
	BlendOp BYTE ?
	BlendFlags BYTE ?
	SourceConstantAlpha BYTE ?
	AlphaFormat BYTE ?
BLENDFUNCTION ends

CLEARTYPE_QUALITY equ 5
ANTIALIASED_QUALITY equ 4

sSIZE STRUCT
	ww DWORD ?
	wh DWORD ?
sSIZE ends


; Proto's

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
LoadPng proto :DWORD,:DWORD
CreateCanvas proto :DWORD,:DWORD,:DWORD
PaintSkin proto :DWORD
PreMul proto :DWORD
PaintText proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
AlphaBlend2 proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
PaintWindow proto :DWORD
ColorizeSkin proto :DWORD,:DWORD,:BYTE

WinSize STRUCT
	upy dd ?		; 0
	horizy dd ?		; 16
	downy dd ?		; h-16
	leftx dd ?		; 0
	vertx dd ?		; 16
	rightx dd ?		; w-16
	w dd ?			; w
	h dd ?			; h
WinSize ends

.data
	ClassName db "MainWinClass",0
	AppName  db "Main Window",0
	ptZero POINT <0,0>
	blender BLENDFUNCTION <AC_SRC_OVER,0,255,AC_SRC_ALPHA>
	ws WinSize <0,16,200-16,0,16,300-16,200,300>
	ScrollMax dd 255
	ScrollPos dd 10
	
.data?
	hWin dd ?
	hInstance HINSTANCE ?
	CommandLine LPSTR ?

.code